/***********************************************************************/
/*                                                                     */
/*                              Pio (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*               EPI Pomdapi, INRIA Paris - Rocquencourt               */
/*                                                                     */
/*  Copyright 2005-2014 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/* $Id: send_communication.cpp,v 1.9 2014/01/10 19:22:09 fclement Exp $ */

#include "send_communication.hpp"

using namespace std;


namespace io{
  

  //|--------------------------|
  //|for complete communication|
  //|--------------------------|
  
  
  void begin_communication(ostream& ob){
    ob<<"(\n";
  }
  
  void end_communication(ostream& ob){
    ob<<")\n\n"<<flush;
  }
  
  template<class dataType> void send_typed_values(ostream& ob,dataType& TVC){
    for(unsigned int i=0;i<TVC.values().size();i++){
      send(ob,TVC.values()[i]);
    }
  } 
  
  void send_communication(ostream& ob,Communication & com){
    begin_communication(ob);
    ob<<com.printable_type()<<" <"<<com.size()<<'>';
    if(com.type() == SERVICE)
      ob<<' '<<'\"'<<com.to_service().atom()<<'\"';
    if(com.type() == TASK)
      ob<<' '<<'\"'<<com.to_task().name()<<'\"';
    ob<<"\n";
    send_typed_values(ob,com);
    end_communication(ob);
  }
  
  void send(ostream& ob,Communication & com){send_communication(ob,com);}
  
}
