#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include "bignums.h"

struct b_int gen_prime (int32_t, void (*) (UINT *, uint32_t, int), int);

int fdrand;

static void
xrand (UINT *buffer, uint32_t nbits, int lvl)
{
  int32_t nwords;

  if (nbits%W_SIZE)
    nwords = (nbits+W_SIZE)/W_SIZE;
  else
    nwords = nbits/W_SIZE;

  (void)read(fdrand, buffer, nwords*sizeof(UINT));
  buffer[nwords-1] &= (~(UINT)0)>>(W_SIZE - (nbits%W_SIZE));
}

int
main (int argc, char **argv)
{
  struct b_int prime, mod, tmp;
  unsigned prime_size, i;
  unsigned nmods = sizeof b_primes / sizeof b_primes[0];
  char outbuf[1024];
  mod.neg = '\0';

  fdrand = open("/dev/urandom", O_RDONLY);
  if (fdrand < 0) {
    perror(argv[0]);
    return 1;
  }
  while (1) {
    if (scanf(" %u", &prime_size) < 1) break;
    if (prime_size < W_SIZE) break;

#ifndef NDEBUG
    fprintf(stderr, "%s - Generating %d bits prime.\n", argv[0], prime_size);
#endif
    mod = b_alloc(prime_size); b_zero(mod);
    tmp = b_alloc(prime_size);
    prime = gen_prime(prime_size, xrand, 0);
    b_sprint(outbuf, prime);
    printf("prime = %s\n", outbuf);

    printf("nmods = %d\nmods =", nmods);
    for (i = 0; i < nmods; i++) {
      mod.buffer[0] = b_primes[i];
      b_mod(tmp, prime, mod);
      printf(" %x;", (unsigned)tmp.buffer[0]);
    }
    printf("\n");
    fflush(stdout);
    b_free(mod);
    b_free(tmp);
  }

  close(fdrand);
  return 0;
}
