(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2007-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux <Quentin.Carbonneaux@inria.fr>                 *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: daemon_types.mli,v 1.2 2014/01/21 09:21:16 fclement Exp $ *)

type slave_packet = {
   color : int
};;

type spawn_success = {
   worker_port : int
};;

type spawn_reply =
   | Spawn_success of spawn_success
   | Spawn_failure
;;

type closure_id = int;;

type spawn_request =
   | Spawn_loop of Iotree.ioatree * Iotree.ioatree
   | Spawn_pipe of Iotree.ioatree * Iotree.ioatree
   | Spawn_atom of Obj.t * closure_id
;;
